NOLIST:WRITE"PARTY-CD.PDT":ORG #2000
;
        CALL BLACK
        CALL #BD19
;
        LD   A,#C4
        LD   HL,#4000
        LD   DE,#4BBE
        LD   BC,#D6D
        LD   IX,#5880
        CALL CRNCOP
;
        LD   A,#C5
        LD   HL,#4E00
        LD   DE,#5ECB
        LD   BC,#10E0
        LD   IX,#6F00
        CALL CRNCOP
;
        LD   A,#C6
        LD   HL,#5F00
        LD   DE,#5D65
        LD   BC,#13C6
        LD   IX,#7080
        CALL CRNCOP
;
        LD   A,#C7
        LD   HL,#7300
        LD   DE,#663C
        LD   BC,#12EF
        LD   IX,#7880
        CALL CRNCOP
;
        LD   HL,#1000
        LD   DE,#1001
        LD   (HL),0
        LD   BC,#FFF
        LDIR
;
OVERSC  LD   BC,#BC01     ;OVERSCAN
        OUT  (C),C
        LD   BC,#BD00+48
        OUT  (C),C
        LD   BC,#BC03
        OUT  (C),C
        LD   BC,#BD00+8
        OUT  (C),C
        LD   BC,#BC02
        OUT  (C),C
        LD   BC,#BD00+50
        OUT  (C),C
        LD   BC,#BC06
        OUT  (C),C
        LD   BC,#BD00+21
        OUT  (C),C
        LD   BC,#BC07
        OUT  (C),C
        LD   BC,#BD00+28
        OUT  (C),C
;
INIT    DI                 ;SYSTEMINITIALISIERUNG
        LD   HL,#C9FB      ;INTERRUPTS ABFANGEN
        LD   (#38),HL
        LD   SP,#1FFF
        LD   BC,#BFFF
        LD   HL,#4000
        LD   DE,#4001
        LD   (HL),0
        LDIR
        LD   BC,#7FC6
        OUT  (C),C
        LD   BC,256*80+80
        LD   DE,9*96+#C000
        LD   HL,80*48+#4000
        CALL SPRO
        LD   BC,256*80+15
        LD   DE,9*96+#C000+80
        LD   HL,15*11+#6800
        CALL SPRO
        LD   BC,#7FC4
        OUT  (C),C
        CALL #4000
        LD   BC,#7FC0
        OUT  (C),C
;
        LD   B,#7F
        LD   DE,4*256+#44  ;INK 4,2
        OUT  (C),D
        OUT  (C),E
        LD   DE,5*256+#56  ;INK 5,9
        OUT  (C),D
        OUT  (C),E
        LD   DE,6*256+#52  ;INK 6,18
        OUT  (C),D
        OUT  (C),E
        LD   DE,7*256+#59  ;INK 7,22
        OUT  (C),D
        OUT  (C),E
;
        EI
;
;-----------------------------------MAIN-ROUTINEN
;
FRAME   LD   B,#F5        ;FRAMEFLY
FRAME1  IN   A,(C)
        RRA
        JR   NC,FRAME1
;
        LD   BC,#BC07     ;erster Splitt
        OUT  (C),C
        LD   BC,#BDFF
        OUT  (C),C
        LD   BC,#BC05
        OUT  (C),C
        LD   A,(REG5)
        XOR  7
        INC  A
        INC  B
        OUT  (C),A
        LD   BC,#BC04
        OUT  (C),C
        LD   BC,#BD00+1
        OUT  (C),C
        LD   HL,(ADRVER)
        LD   BC,#BC0C
        OUT  (C),C
        INC  B
        OUT  (C),H
        DEC  B
        INC  C
        OUT  (C),C
        INC  B
        OUT  (C),L
;
        LD   B,0
WAITA   DJNZ WAITA
        LD   B,100
WAITB   DJNZ WAITB
;
        LD   BC,#BC05     ;erster richtiger Splitt
        OUT  (C),C
        LD   A,(REG5)
        INC  B
        OUT  (C),A
        LD   BC,#BC04
        OUT  (C),C
        LD   BC,#BD00+9
        OUT  (C),C
        LD   HL,#3000
        LD   BC,#BC0C
        OUT  (C),C
        INC  B
        OUT  (C),H
        DEC  B
        INC  C
        OUT  (C),C
        INC  B
        OUT  (C),L
;
        LD   BC,#7F8D
        OUT  (C),C
        LD   DE,1*256+#5c  ;INK 1,3
        OUT  (C),D
        OUT  (C),E
        LD   DE,2*256+#57  ;INK 2,11
        OUT  (C),D
        OUT  (C),E
        LD   DE,3*256+#53  ;INK 3,20
        OUT  (C),D
        OUT  (C),E
;
SPLADR  LD   A,(ADRPOS)
        CPL
        LD   (ADRPOS),A
        OR   A
        JR   Z,SPLADR1
        LD   HL,ADRU1
        JR   SPLADR2
SPLADR1 LD   HL,ADRU2
SPLADR2 LD   E,(HL)
        INC  HL
        LD   D,(HL)
        INC  DE
        RES  2,D
        LD   (HL),D
        DEC  HL
        LD   (HL),E
        LD   (ADRUP),DE
        LD   HL,LAUFAD1
        CALL LAUINC
        CALL LAUINC
;
LAUFPR  LD   A,(SFNTPS)
        OR   A
        JR   NZ,LAUFPR2
        LD   HL,(MS1ZGR)
LAUFPR0 LD   A,(HL)
        INC  HL
        OR   A
        JR   NZ,LAUFPR1
        LD   HL,MS1TXT
        JR   LAUFPR0
LAUFPR1 LD   (MS1ZGR),HL
        SUB  64
        LD   B,A
        LD   DE,252
        LD   HL,#4000-252
LAUFPR3 ADD  HL,DE
        DJNZ LAUFPR3
        LD   (SFNTAD),HL
        LD   A,7
LAUFPR2 DEC  A
        LD   (SFNTPS),A
        LD   BC,#7FC5
        OUT  (C),C
        LD   DE,(SFNTAD)
        LD   HL,(LAUFAD1)
        PUSH DE
        CALL FNTCOP
        POP  DE
        LD   HL,(LAUFAD2)
        CALL FNTCOP
        LD   (SFNTAD),DE
        LD   BC,#7FC0
        OUT  (C),C
;
        LD   BC,#7FC7
        OUT  (C),C
        LD   HL,(SPRADR)
        LD   DE,#7100
        CALL SPRIN
        LD   DE,(SPRADR)
        LD   HL,#7000
        CALL SPROUT
        LD   BC,#7FC0
        OUT  (C),C
        HALT
;
        LD   BC,#BC04
        OUT  (C),C
        LD   BC,#BD00+18
        OUT  (C),C
        LD   BC,#BC05
        OUT  (C),C
        LD   BC,#BD00
        OUT  (C),C
        LD   HL,(ADRUP)
        LD   BC,#BC0C
        OUT  (C),C
        INC  B
        OUT  (C),H
        DEC  B
        INC  C
        OUT  (C),C
        INC  B
        OUT  (C),L
;
        LD   BC,#7F8C
        OUT  (C),C
        LD   DE,1*256+#4F ;INK 1,17
        OUT  (C),D
        OUT  (C),E
        LD   DE,2*256+77  ;INK 2,8
        OUT  (C),D
        OUT  (C),E
        LD   DE,3*256+88  ;INK 3,4
        OUT  (C),D
        OUT  (C),E
        LD   HL,COLAKT
        LD   C,8
COLSET  LD   A,C
        ADD  7
        OUT  (C),A
        LD   A,(HL)
        INC  HL
        OUT  (C),A
        DEC  C
        JR   NZ,COLSET
;
RASTER  LD   HL,RASTAB
        LD   A,68
        LD   BC,#7F00
        OUT  (C),C
        DEFS 32
RASTER1 LD   C,(HL)
        INC  HL
        OUT  (C),C
        DEFS 52
        DEC  A
        JR   NZ,RASTER1
        LD   A,84
        OUT  (C),A
;
RASSCL  LD   A,(RASCNT)
        OR   A
        JP   Z,R5VER
        DEC  A
        LD   (RASCNT),A
        LD   DE,RASTAB
        LD   HL,RASTAB+1
        LD   BC,68*2+19
        LDIR
        JP   VERTEND
;
R5VER   LD   A,(REG5)
        INC  A
        AND  7
        LD   (REG5),A
        JR   NZ,VERTIC
        LD   HL,(ADRVER)
        LD   BC,48
        ADD  HL,BC
        RES  2,H
        LD   (ADRVER),HL
;
VERTIC  LD   HL,FNTCL2
        LD   DE,FNTCLR
        LD   BC,24
        LDIR
        LD   A,(FNTPOS)
        OR   A
        JR   NZ,VERTIC3
        LD   HL,(MS2ZGR)
        LD   B,12
        LD   DE,FNTADR
VERTIC1 LD   A,(HL)
        OR   A
        JR   NZ,VERTIC2
        LD   HL,MS2TXT
        JR   VERTIC1
VERTIC2 PUSH BC
        INC  HL
        PUSH HL
        SUB  65
        ADD  A
        LD   L,A
        LD   H,0
        LD   BC,FNTTAB
        ADD  HL,BC
        LDI:LDI
        POP  HL
        POP  BC
        DJNZ VERTIC1
        LD   (MS2ZGR),HL
        LD   A,48
VERTIC3 DEC  A
        LD   (FNTPOS),A
        LD   HL,(FNTSCR)
        AND  7
        JR   Z,VERTIC4
        LD   BC,#800
        ADD  HL,BC
        JR   VERTIC5
VERTIC4 LD   BC,#C860
        ADD  HL,BC
        RES  3,H
VERTIC5 LD   (FNTSCR),HL
        LD   A,(FNTPOS)
        LD   BC,#7FC1
        OUT  (C),C
        CP   8
        LD   DE,FNTCLR
        JR   C,VERTIC6
        LD   DE,FNTADR
VERTIC6 LD   B,12
VERTIC9 PUSH BC
        PUSH DE
        EX   DE,HL
        LD   C,(HL)
        INC  HL
        LD   B,(HL)
        LD   L,C
        LD   H,B
        LDI:LDI:LDI:LDI:LDI:LDI:LDI:LDI
        DEC  DE
        LD   A,(FNTPOS)
        BIT  0,A
        JR   NZ,VERTIC7
        INC  DE
        RES  3,D
        JR   VERTIC8
VERTIC7 RES  3,D
        INC  DE
        SET  3,D
VERTIC8 LD   C,L
        LD   B,H
        POP  HL
        LD   (HL),C
        INC  HL
        LD   (HL),B
        INC  HL
        EX   DE,HL
        POP  BC
        DJNZ VERTIC9
        LD   BC,#7FC0
        OUT  (C),C
;
VERTEND HALT
;
        LD   BC,#7FC4
        OUT  (C),C
        CALL #4003
        LD   BC,#7FC0
        OUT  (C),C
;
        LD   A,(KEYCNT)
        DEC  A
        LD   (KEYCNT),A
        JR   NZ,COLVER0
        LD   A,10
        LD   (KEYCNT),A
        LD   A,#42
        CALL TASTEN
        CP   #7F
        JR   NZ,COLVER0
        LD   A,(COLRIC)
        CPL
        LD   (COLRIC),A
COLVER0 LD   A,(COLRIC)
        OR   A
        JR   Z,COLUP
COLDWN  LD   DE,COLAKT
        LD   A,(DE)
        LD   HL,COLAKT+1
        LD   BC,7
        LDIR
        LD   (DE),A
        JR   COLVER
COLUP   LD   DE,COLAKT+7
        LD   HL,COLAKT+6
        LD   A,(DE)
        LD   BC,7
        LDDR
        LD   (DE),A
COLVER  LD   HL,(COLTIM)
        DEC  HL
        LD   (COLTIM),HL
        LD   A,H
        OR   L
        JR   NZ,LSTSPL
        LD   HL,30*50
        LD   (COLTIM),HL
        LD   HL,(COLZGR)
        LD   BC,8
        ADD  HL,BC
        LD   (COLZGR),HL
        LD   A,(COLCNT)
        INC  A
        CP   COLMAX
        JR   NZ,COLVER1
        XOR  A
        LD   HL,COLTAB
        LD   (COLZGR),HL
COLVER1 LD   (COLCNT),A
        LD   DE,COLAKT
        LD   BC,8
        LDIR
        LD   A,(COLRIC)
        CPL
        LD   (COLRIC),A
;
LSTSPL  HALT
;
        LD   BC,#BC04
        OUT  (C),C
        LD   BC,#BD00+6
        OUT  (C),C
;
        LD   BC,#7F8D
        OUT  (C),C
        LD   DE,1*256+85 ;INK 1,2
        OUT  (C),D
        OUT  (C),E
        LD   DE,2*256+#57 ;INK 2,11
        OUT  (C),D
        OUT  (C),E
        LD   DE,3*256+#53  ;INK 3,20
        OUT  (C),D
        OUT  (C),E
;
        LD   BC,#7FC7
        OUT  (C),C
        LD   DE,(SPRADR)
        LD   HL,#7100
        CALL SPROUT
        LD   BC,#7FC0
        OUT  (C),C
;
SPRVER  LD   A,(SPRXSP)
        LD   C,A
        LD   A,(SPRXZG)
        ADD  A,C
        LD   (SPRXZG),A
        LD   L,A
        LD   H,0
        LD   DE,SPRXTB
        ADD  HL,DE
        LD   C,(HL)
        LD   A,(SPRYSP)
        LD   B,A
        LD   A,(SPRYZG)
        ADD  B
        LD   (SPRYZG),A
        LD   L,A
        LD   H,0
        ADD  HL,HL
        LD   DE,SPRYTB
        ADD  HL,DE
        LD   E,(HL)
        INC  HL
        LD   D,(HL)
        LD   HL,#C060
        ADD  HL,DE
        LD   B,0
        ADD  HL,BC
        LD   (SPRADR),HL
;
SPRKEY  LD   A,(SPRCNT)
        DEC  A
        LD   (SPRCNT),A
        JR   NZ,RESKEY
        LD   A,10
        LD   (SPRCNT),A
        LD   A,#40
        CALL TASTEN
        BIT  0,A
        JP   Z,SPYINC
        BIT  2,A
        JP   Z,SPYDEC
        BIT  1,A
        JP   Z,SPXINC
        LD   A,#41
        CALL TASTEN
        BIT  0,A
        JP   Z,SPXDEC
        JP   RESKEY
;
SPYDEC  LD   A,(SPRYSP)
        DEC  A
        LD   (SPRYSP),A
        JR   RESKEY
SPYINC  LD   A,(SPRYSP)
        INC  A
        LD   (SPRYSP),A
        JR   RESKEY
SPXDEC  LD   A,(SPRXSP)
        DEC  A
        LD   (SPRXSP),A
        JR   RESKEY
SPXINC  LD   A,(SPRXSP)
        INC  A
        LD   (SPRXSP),A
;
RESKEY  LD   A,#45
        CALL TASTEN
        CP   #7F
        JP   Z,PARTEND
;
        LD   BC,#BC07
        OUT  (C),C
        LD   BC,#BD00
        OUT  (C),C
;
        JP   FRAME
;
READ "PARTY-SB.INC"
;
CRNCOP PUSH IX:PUSH DE:PUSH BC:LD DE,#C000:PUSH DE:LDIR:LD B,#7F:OUT (C),A:LD HL,#4000:LD (HL),0:LD DE,#4001:LD BC,#3FFF:LDIR:POP HL:POP BC:POP DE:LDIR:POP HL:LD (CRNCP1+1),HL
CRNCP1 CALL 0:LD BC,#7FC0:OUT (C),C:RET
;
SPRCNT  DEFB 1
SPRADR  DEFW #C060
SPRXTB
DEFB #00,#00,#01,#02,#03,#04,#05,#06,#07,#08,#09,#0A,#0B,#0C,#0D,#0E,#0F,#10,#11,#12,#13,#14,#15,#16,#17,#18,#19,#1A,#1A,#1B,#1C,#1D,#1E,#1F,#20,#21,#22,#23,#23,#24,#25,#26,#27,#28,#29,#29,#2A,#2B,#2C,#2D,#2E,#2E,#2F,#30,#31,#31,#32,#33,#34,#34,#35,#36
DEFB #37,#37,#38,#39,#39,#3A,#3B,#3B,#3C,#3D,#3D,#3E,#3F,#3F,#40,#40,#41,#41,#42,#43,#43,#44,#44,#45,#45,#46,#46,#47,#47,#47,#48,#48,#49,#49,#49,#4A,#4A,#4A,#4B,#4B,#4B,#4C,#4C,#4C,#4D,#4D,#4D,#4D,#4E,#4E,#4E,#4E,#4E,#4E,#4F,#4F,#4F,#4F,#4F,#4F,#4F,#4F
DEFB #4F,#4F,#4F,#4F,#4F,#4F,#4F,#4F,#4F,#4F,#4F,#4F,#4F,#4F,#4F,#4F,#4F,#4E,#4E,#4E,#4E,#4E,#4E,#4D,#4D,#4D,#4D,#4C,#4C,#4C,#4B,#4B,#4B,#4A,#4A,#4A,#49,#49,#49,#48,#48,#47,#47,#47,#46,#46,#45,#45,#44,#44,#43,#43,#42,#41,#41,#40,#40,#3F,#3F,#3E,#3D,#3D
DEFB #3C,#3B,#3B,#3A,#39,#39,#38,#37,#37,#36,#35,#34,#34,#33,#32,#31,#31,#30,#2F,#2E,#2E,#2D,#2C,#2B,#2A,#29,#29,#28,#27,#26,#25,#24,#23,#23,#22,#21,#20,#1F,#1E,#1D,#1C,#1B,#1A,#1A,#19,#18,#17,#16,#15,#14,#13,#12,#11,#10,#0F,#0E,#0D,#0C,#0B,#0A,#09,#08
DEFB #07,#06,#05,#04,#03,#02,#01,#00
SPRXZG  DEFB 0
SPRXSP  DEFB 1
SPRYTB
DEFW #3CE0,#3CE0,#3CE0,#3CE0,#3CE0,#3CE0,#3CE0,#3CE0,#3CE0,#3CE0,#3CE0,#34E0,#34E0,#34E0,#34E0,#34E0,#2CE0,#2CE0,#2CE0,#24E0,#24E0,#24E0,#1CE0,#1CE0,#1CE0,#14E0,#14E0,#CE0,#CE0,#4E0,#4E0,#3C80,#3C80,#3480,#3480,#2C80,#2C80,#2480,#2480,#1C80,#1480,#1480
DEFW #C80,#480,#480,#3C20,#3420,#2C20,#2C20,#2420,#1C20,#1420,#C20,#C20,#420,#3BC0,#33C0,#2BC0,#23C0,#1BC0,#13C0,#13C0,#BC0,#3C0,#3B60,#3360,#2B60,#2360,#1B60,#1360,#B60,#360,#3B00,#2B00,#2300,#1B00,#1300,#B00,#300,#3AA0,#32A0,#2AA0,#1AA0,#12A0,#AA0,#2A0
DEFW #3A40,#3240,#2240,#1A40,#1240,#A40,#39E0,#31E0,#29E0,#21E0,#11E0,#9E0,#1E0,#3980,#2980,#2180,#1980,#980,#180,#3920,#2920,#2120,#1920,#920,#120,#38C0,#28C0,#20C0,#18C0,#8C0,#C0,#3860,#2860,#2060,#1060,#860,#60,#3000,#2800,#2000,#1000,#800,#0,#1000
DEFW #1800,#2800,#3000,#3800,#860,#1060,#1860,#2860,#3060,#C0,#8C0,#10C0,#20C0,#28C0,#30C0,#120,#920,#1120,#2120,#2920,#3120,#180,#980,#1180,#2180,#2980,#3180,#1E0,#9E0,#11E0,#19E0,#29E0,#31E0,#39E0,#240,#1240,#1A40,#2240,#2A40,#3A40,#2A0,#AA0,#12A0
DEFW #1AA0,#22A0,#32A0,#3AA0,#300,#B00,#1300,#1B00,#2300,#2B00,#3300,#360,#B60,#1360,#1B60,#2360,#2B60,#3360,#3B60,#3C0,#BC0,#13C0,#1BC0,#1BC0,#23C0,#2BC0,#33C0,#3BC0,#420,#C20,#1420,#1420,#1C20,#2420,#2C20,#3420,#3420,#3C20,#480,#C80,#C80,#1480,#1C80
DEFW #1C80,#2480,#2C80,#2C80,#3480,#3480,#3C80,#3C80,#4E0,#4E0,#CE0,#CE0,#14E0,#14E0,#1CE0,#1CE0,#24E0,#24E0,#24E0,#2CE0,#2CE0,#2CE0,#34E0,#34E0,#34E0,#3CE0,#3CE0,#3CE0,#3CE0,#3CE0,#540,#540,#540,#540,#540,#540,#540,#540,#540,#540
SPRYZG  DEFB 0
SPRYSP  DEFB 1
;
ADRVER  DEFW #1000        ;VERTICAL SCROLLER
REG5    DEFB 0
FNTPOS  DEFB 0            ;WIEVIEL VOM FONT
MS2ZGR  DEFW MS2TXT
FNTADR  DEFS 12*2         ;MEM-ADR DER EINZELNEN ZEICHEN
FNTCLR  DEFW #1000,#1000,#1000,#1000,#1000,#1000,#1000,#1000,#1000,#1000,#1000,#1000
FNTCL2  DEFW #1000,#1000,#1000,#1000,#1000,#1000,#1000,#1000,#1000,#1000,#1000,#1000
FNTSCR  DEFW 96*10+#4000        ;SCR-ADR
FNTTAB  DEFW #C000,#C140,#C280,#C3C0,#C500,#C640,#C780,#C8C0,#CA00,#CB40,#CC80,#CDC0,#CF00,#D040,#D180,#D2C0,#D400,#D540,#D680,#D7C0,#D900,#DA40,#DB80,#DCC0,#DE00,#DF40,#E080,#E1C0,#E300,#E440,#E580,#E6C0
;
RASTAB  DEFB 84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84,84
        DEFB 84,84,84,84,84,84,84,84
RASTB1  DEFB 88,77,#4F,75,75,#4F,77,88,84,84,84,#5C,84,84,84,#5C,84,#5C,#5C,#5C,#4C,#5C,#5C,#5C,#4C,#5C,#4C,#4C,#4C,#4E,#4C,#4C,#4C,#4E,#4C,#4E,#4E,#4E,#4A,#4E,#4E,#4E,#4A,#4E,#4A,#4A,#4A,#43,#4A,#4A,#4A,#43,#4A,#43,#43,#43,75,#43,#43,#43,75,#43,75,75,75
        DEFB 75,75,84     ;raster
RASCNT  DEFB 88
;
KEYCNT  DEFB 1
COLTAB  DEFB #40,#40,#40,#40,75,75,75,75
        DEFB 68,68,68,68,85,85,85,85
        DEFB #52,#52,#52,#52,#56,#56,#56,#56
        DEFB 84,68,85,#57,#53,75,#4F,77
        DEFB #4C,#4C,#4C,#4C,#4E,#4E,#4E,#4E
        DEFB 85,85,85,85,#57,#57,#57,#57
        DEFB #5E,#5E,#5E,#5E,#4A,#4A,#4A,#4A
        DEFB 84,#5C,#4C,#4E,#4A,75,#52,#56
        DEFB #57,#57,#57,#57,#53,#53,#53,#53
        DEFB #5C,#5C,#5C,#5C,#4C,#4C,#4C,#4C
        DEFB 77,77,77,77,88,88,88,88
COLAKT  DEFB 84,84,84,84,84,84,84,84
COLZGR  DEFW COLTAB
COLTIM  DEFW 10*50
COLCNT  DEFB 0
COLRIC  DEFB 0  ;0/1=RAUF/RUNTER
COLMAX  EQU  11
;
ADRUP   DEFW #2000        ;HORIZONTALER SCROLL
ADRU1   DEFW #2000
ADRU2   DEFW #2200
ADRPOS  DEFB 0
LAUFAD1 DEFW #8000+95
LAUFAD2 DEFW #8400+94
MS1ZGR  DEFW MS1TXT
SFNTAD  DEFW 0
SFNTPS  DEFB 0
;
PARTEND EQU  0
;
READ "party-TX.INC"
;
LIST:END
